Bug 213048 - Make _WKWebsiteDataStoreConfiguration SPI for HSTS storage to replace _WKProcessPoolConfiguration.hstsStorageDirectory
Summary: Make _WKWebsiteDataStoreConfiguration SPI for HSTS storage to replace _WKProc...
Status: REOPENED
Alias: None
Product: WebKit
Classification: Unclassified
Component: New Bugs (show other bugs)
Version: WebKit Nightly Build
Hardware: Unspecified Unspecified
: P2 Normal
Assignee: Alex Christensen
URL:
Keywords: InRadar
Depends on: 213781 213933
Blocks:
  Show dependency treegraph
 
Reported: 2020-06-10 14:09 PDT by Alex Christensen
Modified: 2020-07-03 12:58 PDT (History)
9 users (show)

See Also:


Attachments
Patch (37.01 KB, patch)
2020-06-10 14:16 PDT, Alex Christensen
no flags Details | Formatted Diff | Diff
Patch (37.10 KB, patch)
2020-06-15 10:10 PDT, Alex Christensen
no flags Details | Formatted Diff | Diff
Patch (37.10 KB, patch)
2020-06-15 10:13 PDT, Alex Christensen
no flags Details | Formatted Diff | Diff
Patch (36.94 KB, patch)
2020-06-15 13:04 PDT, Alex Christensen
no flags Details | Formatted Diff | Diff
patch (35.96 KB, patch)
2020-07-02 20:34 PDT, Alex Christensen
no flags Details | Formatted Diff | Diff
patch (35.96 KB, patch)
2020-07-02 20:34 PDT, Alex Christensen
no flags Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Alex Christensen 2020-06-10 14:09:28 PDT
Make _WKWebsiteDataStoreConfiguration SPI for HSTS storage to replace _WKProcessPoolConfiguration.hstsStorageDirectory
Comment 1 Alex Christensen 2020-06-10 14:16:53 PDT
Created attachment 401582 [details]
Patch
Comment 2 Darin Adler 2020-06-10 14:56:45 PDT
Comment on attachment 401582 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=401582&action=review

> Source/WTF/wtf/PlatformHave.h:413
> +    || (PLATFORM(IOS) && __IPHONE_OS_VERSION_MIN_REQUIRED >= 140000) \

Should be:

    || ((PLATFORM(IOS) || PLATFORM(MACCATALYST) && __IPHONE_OS_VERSION_MIN_REQUIRED >= 140000) \

As I recently learned from Tim Horton.
Comment 3 Alex Christensen 2020-06-15 10:10:45 PDT
Created attachment 401905 [details]
Patch
Comment 4 Alex Christensen 2020-06-15 10:13:26 PDT
Created attachment 401907 [details]
Patch
Comment 5 Alex Christensen 2020-06-15 13:04:23 PDT
Created attachment 401926 [details]
Patch
Comment 6 youenn fablet 2020-06-19 01:42:34 PDT
Comment on attachment 401926 [details]
Patch

LGTM overall.
Can we add some API tests covering HSTS?
Comment 7 Alex Christensen 2020-06-19 10:53:55 PDT
Unfortunately, manual verification is the best we have right now.  I've tried hard in the past, but HSTS apparently only persists data in sandboxed apps, and it does not persist in a timely manner.
Comment 8 EWS 2020-06-29 21:39:55 PDT
Committed r263724: <https://trac.webkit.org/changeset/263724>

All reviewed patches have been landed. Closing bug and clearing flags on attachment 401926 [details].
Comment 9 Radar WebKit Bug Importer 2020-06-29 21:40:14 PDT
<rdar://problem/64922940>
Comment 10 Yusuke Suzuki 2020-06-30 02:24:21 PDT
Re-opened since this is blocked by bug 213781
Comment 11 David Quesada 2020-06-30 10:07:44 PDT
Comment on attachment 401926 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=401926&action=review

> Source/WebKit/UIProcess/API/Cocoa/_WKWebsiteDataStoreConfiguration.mm:301
> +        [NSException raise:NSInvalidArgumentException format:@"Cannot set mediaKeysStorageDirectory on a non-persistent _WKWebsiteDataStoreConfiguration."];

This should say `Cannot set hstsStorageDirectory...`
Comment 12 Alex Christensen 2020-07-02 20:34:10 PDT
Created attachment 403435 [details]
patch
Comment 13 Alex Christensen 2020-07-02 20:34:55 PDT
Created attachment 403436 [details]
patch
Comment 14 EWS 2020-07-02 21:17:59 PDT
Committed r263882: <https://trac.webkit.org/changeset/263882>

All reviewed patches have been landed. Closing bug and clearing flags on attachment 403436 [details].
Comment 15 Yusuke Suzuki 2020-07-03 12:57:58 PDT
Re-opened since this is blocked by bug 213933
Comment 16 Alexey Proskuryakov 2020-07-03 12:58:13 PDT
This broke the build, reverting. Details in Slack.